#ifndef PARSERCLASS_H
#define PARSERCLASS_H
#include <dirent.h>
#include <string>
#include <sstream>
#include <algorithm>
#include <iterator>
#include <vector>
#include <fstream>
#include <iostream>
#include <map>
#include <bits/stdc++.h>
using namespace std;

class Parser{
private:  
    int nOptions;
    int isOption(const char*);
    int inputParser(char**, const string&);
    void cmdLineHelp();
    void replaceString(string&, const string&, const string&);

    vector<vector<string>> helpOpt = {
    {"-i", 
        "<inference type [0/1]>",
        "0 - Search for best M (with α and θ fixed) \n" 
        "1 - Search for Dirichlet parameters (with M fixed) \n" 
        "Default: 0"},
    {"-p", 
        "<input alignment paths with inferred time from SSTTime>",
        "File containing paths to secondary structure alignments and inferred times \n"
        "Format <path> <inferred time> (files should be in FASTA format)\n" 
        "Default: data/test-paths.txt"},    
    {"-a", 
        "<input secondary structure alphabet>",
        "File containing the secondary structure alphabet\n" 
        "Default: data/sseAlphabet.txt"},  
    {"-m", 
        "<file containing the initial matrix to use in the inference>",
        "3x3 matrix with probabilties in the order of input alphabet \n" 
        "Default: data/initM.txt"},    
    {"-d", 
        "<input dirichlet file>",
        "Input file containing the Dirichlet parameters for match, insert state. \n"
        "Format: <time> <2 model parameters for match state> <3 model parameters for insert state>\n"
        "Default: data/initDirichlet.txt"},  
    {"-o", 
        "<output folder>",
        "File to write M or Dirichlet parameters\n"
        "Default: output"},  
    {"-t", 
        "<upper bound for time>",
        "Upper bound for structure time (t) \n" 
        "Default: 250"},      

    {"--help", "",
        "Displays help options and exit.\n"}      
    };

public:
    size_t timeUB = 250;
    int inferencetype = 0;
    string sseFile = "data/sseAlphabet.txt";
    string initMFile = "data/initM.txt";
    string initDirFile = "data/initDirichlet.txt";
    string outfldr = "output";
    string inpfile = "data/test-paths.txt";
    string nullFile = "data/nullEstimates.txt";
    
    Parser();
    Parser(int, char **);
};

#endif