#ifndef DIRMANAGER_H
#define DIRMANAGER_H

#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <string>
#include <stdint.h>
#include <map>
#include <vector>
#include <sstream>
#include <bits/stdc++.h>
#include "dirichlet.h"
#include "sseAlignment.h"
#include "util.h"
using namespace std;


class DirManager{
    private:
        vector<Dirichlet> alphaM;
        vector<Dirichlet> alphaI;

        void load_dir_data(const string, int);
       
    public:
        DirManager();
        DirManager(const int);
        DirManager(const string, int);
        Dirichlet getMatchDirichlet(const int);
        Dirichlet getIndelDirichlet(const int);
        int getSize();
        void insert(Dirichlet&, int);
        void print(string);
};

#endif
