#ifndef DIR_H
#define DIR_H

#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <string>
#include <stdint.h>
#include <map>
#include <vector>
#include <sstream>
#include <bits/stdc++.h>
#include "util.h"
#include "sseAlignment.h"
using namespace std;

class Dirichlet{
    private:
        int k;
        double kappa_polygamma;
        double kappa_lgamma;
        double k2log_lattice_const;
        double klog_lattice_const;
        double I_mean;
        double kover2;
        vector<double> alpha;
        vector<double> alpha_lgammas;
        double alpha_sum;
       
        double log_det_fisher(const int&);
        void init();
   
    public:
        Dirichlet();
        Dirichlet(int, vector<double>, double);
        double I_alpha(const int&);
        double I_theta_plus_I_A(SSEAlign&, const vector<int>&);
        double I_A(SSEAlign&, const vector<int>&);
        double constTerms(const int&);
        vector<double> getAlpha();
        double getKappa();
        vector<double> getMean();
        int getK();
        bool isValid();
        string print();
        bool isEmpty();
        vector<double> computeThetaMode();
        vector<double> computeThetaMean();
};

#endif
