#ifndef SIMANNEALDIR_H
#define SIMANNEALDIR_H

#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <string>
#include <stdint.h>
#include <map>
#include <vector>
#include <random>
#include <sstream>
#include <bits/stdc++.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "sseMat.h"
#include "sseAlignment.h"
#include "dirManager.h"
#include "util.h"
#include "aaAlphabet.h"
#include "threeStateDP.h"
using namespace std;


class EMDir{
    private:
        double startingKelv = 10000;
        double kelvProb = 0.88;
        double kelvin;
        double stoppingKelv = 0.0001;
        int perturbations = 5000;
        int iter = 0;
        double tolerance = 0.000001;

        double initCost;
        double currCost;
        string logF;
        bool printLog = false;

        DirManager dirmg;
        DirManager inferreddm;
        AAAlphabet ssealph;
        vector<vector<SSEAlign>> binnedAlignments;
        default_random_engine random_number_generator;

        double cost_objective_function(Dirichlet&, int, vector<int> (SSEAlign::*dirTransitionFunction)());
        string getLegend(double, double, int, int, Dirichlet&);
        Dirichlet annealDirichlet(int, Dirichlet&, vector<int> (SSEAlign::*dirTransitionFunction)());
        double uniform_random(double, double);
  	    double gamma_random(double, double);
        vector<double> perturbProbVec(const vector<double>&, const double&);
        Dirichlet perturbDirichlet(Dirichlet&);

    public:
        EMDir();
        EMDir(const string, const string, AAAlphabet&, int);
        void anneal();
        void writeOutput(string);
};

#endif

