#ifndef SIMANNEAL_H
#define SIMANNEAL_H

#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <string>
#include <stdint.h>
#include <map>
#include <vector>
#include <sstream>
#include <bits/stdc++.h>
#include "sseMat.h"
#include "sseAlignment.h"
#include "dirManager.h"
#include "util.h"
#include "aaAlphabet.h"
#include "threeStateDP.h"
using namespace std;


class EMMat{
    private:
        double kelvin = 10000;
        double kelvProb = 0.88;
        double stoppingKelv = 0.0001;
        int perturbations = 5000;
        int iter = 0;
        double kappaFactor = 100.0/88.0;
        double kappa = 10000.0;
        double tolerance = 0.000001;

        double initCost;
        double currCost;
        string logF;
        int timeUB;
        bool printLog = false;

        Submat initmat;
        Submat acceptedMat;
        DirManager dir;
        AAAlphabet ssealph;
        vector<SSEAlign> alignments;
        vector<vector<int>> binnedAlignments;
        default_random_engine random_number_generator;

        pair<double, int>  cost_objective_function(Submat&);
        vector<vector<double>> perturbMatrix(const vector<vector<double>>, vector<double>&);
        string getLegend(double, double, int, Submat&);
        double gamma_random(double, double);
        int roulette_random(vector<double>);

    public:
        EMMat();
        EMMat(Submat&, DirManager&, const string, AAAlphabet&, int);
        void anneal();
        void writeOutput(string&);
};

#endif
