#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <string>
#include <map>
#include <vector>
#include <sstream>
#include <algorithm>
#include "cmdLineParser.h"
#include "emMat.h"
#include "emDir.h"
using namespace std;

int main( int argc , char *argv[]) {

    Parser inp = Parser(argc, argv);

    AAAlphabet ssealph(inp.sseFile);
    int typeSize = ssealph.size();

    if(inp.inferencetype == 0){
        // Matrix inference
        DirManager dirmng(inp.initDirFile, inp.timeUB);

        Submat ssemat(inp.initMFile, inp.timeUB);
       
        EMMat expMax(ssemat, dirmng, inp.inpfile, ssealph, inp.timeUB);
        expMax.anneal();
        expMax.writeOutput(inp.outfldr);

    } else if(inp.inferencetype == 1){

        // Dirichlet inference
        EMDir em(inp.initDirFile, inp.inpfile, ssealph, inp.timeUB);
        em.anneal();
        em.writeOutput(inp.outfldr);
    } else assert(false);
 
    return 0;
}


