#ifndef SSTALIGN_H
#define SSTALIGN_H

#include <fstream>
#include <cassert>
#include <stdio.h> 
#include <string>
#include <bits/stdc++.h>
#include <map>
#include <tuple>
#include <vector>
using namespace std;


class SSEAlign {
   private:
        string header;
        string align1;
        string align2;
        string matchRegion1;
        string matchRegion2;
        string insertRegion;
        string deleteRegion;
        string fsastr;
        // curr | prev = transition[prev][curr]
        vector<vector<int>> transitions; 
        vector<int> mTransitions;
        vector<int> iTransitions;
        map<string, int> matchCounts;
        map<char, int> indelCounts;
        int totTrans;
        int state2Indx(char);

   public:
        SSEAlign();
        SSEAlign(string, string, string);
        int size();
        vector<string> getAlignments();
        vector<string> getMatchRegion();
        string getInsertRegion();
        string getDeleteRegion();
        string getHeader();
        string getFSAstr();
        string getFirstAlignment();
        string getSecondAlignment();
        int getTransitions(char, char);
        int getTransitions(char);
        vector<int> getMTransitionVec();
        vector<int> getITransitionVec();
        map<string, int> getMatchCounts();
        map<char, int> getIndelCounts();
};

#endif